**Программный комплекс Artix:SCO является интеллектуальной собственностью ИП Заболотная Е.А. и охраняется законом согласно ст. 1225 ГК РФ. Запрещается любое использование программного комплекса Artix:SCO, как целиком, так и его отдельных компонентов (API, интерфейс, сервисы, алгоритмы и др.), без письменного разрешения ИП Заболотная Е.А.**

# Скрипты для эмуляции работы POS
Эти скрипты загружаются и выполняются тестовым GRPC клиентом Artix:SCO, они реализуют бизнес логику POS. Используется для упрощения тестирования, также может использоваться в качестве примера при интеграцияи с клиентским приложением.

## Рекомендации по разработке
Рекомендуется использовать Visual Studio Code в качестве редактора, в нем есть подсветка синтаксиса, автоформатирование и автоподстановки. VS Code можно скачать [на официальном сайте](https://code.visualstudio.com/).

При использовании VS Code надо:

* Установить плагин [ESLint](https://marketplace.visualstudio.com/items?itemName=dbaeumer.vscode-eslint)
* Установить [Node.js / npm](https://nodejs.org/en/)
* В этом каталоге выполнить локальную установку необходимых для eslint модулей.
  ```bash
  npm install
  ```

## Особенности реализации

* JS код выполняется на встроенном в Qt JavaScript движке, поддерживается стандарт [ECMAScript 2018](http://www.ecma-international.org/publications/files/ECMA-ST/Ecma-262.pdf). Нет некоторых вещей которые доступны в браузере или node.js, например нет setTimeout, нет возможности выполнять что-то асинхронно.
* Интерфейс приложения и скрипт работают в одном, главном потоке, остановка выполнения скрипта повлечет за собой "зависание" интерфейса.
* Вызов методов `grpc.call()` работает в отдельном потоке и не блокирует выполнение основного потока.
* В скрипте должны быть экспортированы следующие функции:
  * `eventsRequest()` - возвращает объект с параметрами выполнения API метода `events()`, вызывается при старте скрипта
  * `onEvent(event)` - вызывается при получении события от SCO, где event полученное событие
* Из скрипта можно вызывать API методы при помощи `grpc.call(name, request)`, где name это название метода API, request это объект с параметрами запроса. Возвращает объект вида`{"status": 0, "reply": {}}`, где status это числовой код статуса выполнения метода API, reply это объект с полученным сообщением
