#!/bin/bash

CUR_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null 2>&1 && pwd )"

LOG_FILE=$CUR_DIR/../../logs/service.log
log () {
    LOG_DIR=`dirname $LOG_FILE`
    [ -d $LOG_DIR ] || mkdir -p $LOG_DIR
    while read data; do
        echo "$(date +"%F %X.%3N") - $data" >> $LOG_FILE
    done
}
exec > >(log) 2>&1

echo "Старт сервиса"
echo "DISPLAY=$DISPLAY"
echo "XAUTHORITY=$XAUTHORITY"

echo "Установка разрешения на всех мониторах"
OUTPUTS=$(xrandr | grep connected | sed "s/\s.*//g")
for OUTPUT in $OUTPUTS; do
    xrandr --output $OUTPUT --mode 1024x768
done

echo "Отключение режима энергосбережения монитора"
xset s off
xset -dpms

echo "Старт клиента"
$CUR_DIR/../sst-client -a localhost:3200 -s $CUR_DIR/../js/pos.js >> $CUR_DIR/../../logs/client.log &

echo "Старт SCO"
$CUR_DIR/../../bin/sst-sco
case $? in
    1)
        echo "Перезагрузка"
        shutdown -r now
        ;;
    2)
        echo "Выключение"
        shutdown -h now
        ;;
esac

echo "Остановка клиента"
pkill sst-client

echo "Перезапуск"
